"""
Django settings for newspaper project.

Generated by 'django-admin startproject' using Django 3.0.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

import os
import django_heroku

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'i*fcch(#((x3e-g2q8&=(h_dwi8kjh-!juzt59-+k$53(f2zo4'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['*']


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'whitenoise.runserver_nostatic',    #order matters, whitenoise before staticfiles.
    'django.contrib.staticfiles',

    # Third party apps
    'crispy_forms',

    # Local apps
    'pages.apps.PagesConfig',
    'blog.apps.BlogConfig',
    # 'accounts.apps.AccountsConfig',     # Using django user model
    'users.apps.UsersConfig',           # Customizing django user model
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'whitenoise.middleware.WhiteNoiseMiddleware',       # order matters, whitenoise.
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'newspaper.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'newspaper.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.0/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
    }
}


# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Kathmandu'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

# For CDN
# STATIC_HOST = os.environ.get('DJANGO_STATIC_HOST', '')
# STATIC_HOST = 'https://d4663kmspf1sqa.cloudfront.net' if not DEBUG else ''
# STATIC_URL += STATIC_HOST + '/static/'
# End of For CDN

STATIC_URL = '/static/'
STATICFILES_DIRS = [os.path.join(BASE_DIR, 'static')]                               # For root level static folder .
STATIC_ROOT = os.path.join(BASE_DIR, 'staticfiles')
STATICFILES_STORAGE = 'whitenoise.storage.CompressedManifestStaticFilesStorage'     # Whitenoise configuration

# Custom settings

LOGIN_REDIRECT_URL = "pages:home"       # Redirect after successful login
LOGOUT_REDIRECT_URL = "login"           # Redirect after logout


AUTH_USER_MODEL = "users.CustomUser"        # custom user
CRISPY_TEMPLATE_PACK = 'bootstrap4'

# EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'                # To send mails to console.
EMAIL_BACKEND           = 'django.core.mail.backends.smtp.EmailBackend'           # To send mails to Email.
EMAIL_HOST              = 'smtp.sendgrid.net'
EMAIL_HOST_USER         = 'apikey'
EMAIL_HOST_PASSWORD     = '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'
EMAIL_PORT              = 587
EMAIL_USE_TLS           = True
# email configuration ends here.


django_heroku.settings(locals())    # for heroku deployment
